---
updatedAt: 2026-05-02T21:29:11.000Z
agentTools:
  projectIndex: https://developer.tenable.com/llms.txt
---

# Create connector

Creates a Tenable Vulnerability Management cloud connector.

**Note:** For AWS cloud connectors, you can get the available AWS cloudtrails for your account via the [POST /settings/connectors/aws/cloudtrails](#io-connectors-get-aws-cloudtrails) endpoint.

**Note:** Frictionless Assessment has reached the End-of-Provisioning phase of its product lifecycle. For more information, see [Frictionless Assessment End-of-Provisioning](https://developer.tenable.com/changelog/tenableio-frictionless-assessment-end-of-provisioning). <div class="perms-callout">Requires the Administrator [64] user role. See [Roles](doc:roles).</div>

# OpenAPI definition

```json
{
  "openapi": "3.1.2",
  "info": {
    "title": "Tenable Platform & Settings",
    "version": "1.0.0"
  },
  "servers": [
    {
      "url": "https://cloud.tenable.com"
    }
  ],
  "tags": [
    {
      "name": "Cloud Connectors",
      "x-displayName": "Cloud Connectors"
    }
  ],
  "paths": {
    "/settings/connectors": {
      "post": {
        "summary": "Create connector",
        "description": "Creates a Tenable Vulnerability Management cloud connector.\n\n**Note:** For AWS cloud connectors, you can get the available AWS cloudtrails for your account via the [POST /settings/connectors/aws/cloudtrails](#io-connectors-get-aws-cloudtrails) endpoint.\n\n**Note:** Frictionless Assessment has reached the End-of-Provisioning phase of its product lifecycle. For more information, see [Frictionless Assessment End-of-Provisioning](https://developer.tenable.com/changelog/tenableio-frictionless-assessment-end-of-provisioning). <div class=\"perms-callout\">Requires the Administrator [64] user role. See [Roles](doc:roles).</div>",
        "operationId": "io-connectors-create",
        "tags": [
          "Cloud Connectors"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-ConnectorCreate"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returned if the cloud connector was created successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "connector": {
                      "$ref": "#/components/schemas/Cloud_Connectors_Response-Connector"
                    }
                  }
                },
                "examples": {
                  "AWS (Keyed)": {
                    "value": {
                      "connector": {
                        "type": "aws",
                        "human_type": "AWS",
                        "data_type": "assets",
                        "name": "AWS Connector - Keyed",
                        "status": "Scheduled",
                        "status_message": "",
                        "schedule": {
                          "units": "days",
                          "value": 1
                        },
                        "schedule_full": {
                          "units": "days",
                          "value": 1
                        },
                        "date_created": "2025-12-31T20:50:23.635Z",
                        "id": "6d75a992-0727-4d84-aa5f-ebae0185868b",
                        "container_uuid": "154a05bd-3f27-495a-a001-a659c24eb1a4",
                        "expired": false,
                        "incremental_mode": false,
                        "params": {
                          "access_key": "AKIAIOSFODNN7EXAMPLE",
                          "trails": [
                            {
                              "arn": "arn:aws:cloudtrail:us-east-1:111122223333:trail/ExampleAWSTrail",
                              "name": "ExampleAWSTrail",
                              "region": {
                                "name": "All",
                                "friendly_name": "All"
                              },
                              "availability": ""
                            }
                          ],
                          "service": "aws"
                        },
                        "network_uuid": "2825e3c9-16be-41f4-8b83-dfe534d10627"
                      }
                    }
                  },
                  "AWS (Keyless) (Discovery Only)": {
                    "value": {
                      "connector": {
                        "network_uuid": "00000000-0000-0000-0000-000000000000",
                        "name": "AWS Keyless Discovery Connector",
                        "type": "aws_keyless",
                        "schedule": {
                          "units": "minutes",
                          "value": 30
                        },
                        "params": {
                          "sub_accounts": [
                            {
                              "account_id": "123456789012",
                              "trails": []
                            }
                          ]
                        }
                      }
                    }
                  },
                  "AWS with Frictionless Assessment": {
                    "value": {
                      "connector": {
                        "type": "aws_fa",
                        "human_type": "AWS Frictionless Assessment",
                        "data_type": "assets",
                        "name": "TEST AWS_FA1",
                        "status": "Saved",
                        "status_message": "FA Enabled",
                        "date_created": "2026-05-31T17:13:59.026Z",
                        "id": "1fb9f3da-54a2-493f-9039-bca8d3bf3654",
                        "container_uuid": "ac737cab-114a-4cc1-9f14-07319a20e5a1",
                        "expired": false,
                        "incremental_mode": false,
                        "params": {
                          "service": "aws_fa",
                          "tag": {
                            "key": "TEST",
                            "value": "EXAMPLE"
                          },
                          "account": {
                            "account_id": "444455556666",
                            "role_arn": "arn:aws:iam::444455556666:role/tenableio-connector_dev"
                          }
                        },
                        "network_uuid": "00000000-0000-0000-0000-000000000000"
                      }
                    }
                  },
                  "Azure": {
                    "value": {
                      "connector": {
                        "type": "azure",
                        "human_type": "Azure",
                        "data_type": "assets",
                        "name": "Azure Connector",
                        "status": "Scheduled",
                        "status_message": "",
                        "schedule": {
                          "units": "days",
                          "value": 1,
                          "is_empty": false
                        },
                        "date_created": "2026-08-06T21:27:30.784Z",
                        "id": "1b372203-f5fb-4ee9-8940-680b750c0378",
                        "container_uuid": "77218c8a-0035-4074-90fe-81da235045d4",
                        "expired": false,
                        "incremental_mode": false,
                        "params": {
                          "application_id": "appid",
                          "tenant_id": "tenid",
                          "import_config": false,
                          "subscription_id": [],
                          "service": "azure"
                        },
                        "network_uuid": "00000000-0000-0000-0000-000000000000"
                      }
                    }
                  },
                  "Azure with Frictionless Assessment": {
                    "value": {
                      "connector": {
                        "type": "azure_fa",
                        "human_type": "Azure Frictionless Assessment",
                        "data_type": "assets",
                        "name": "Azure Frictionless Assessment Connector",
                        "status": "Saved",
                        "status_message": "",
                        "date_created": "2025-11-22T05:53:47.131Z",
                        "id": "e8ea5b08-e50c-4469-80df-32c9639bec32",
                        "container_uuid": "af90392b-646e-4a45-ba07-5670efee1b08",
                        "expired": false,
                        "incremental_mode": false,
                        "params": {
                          "service": "azure_fa",
                          "targets": [
                            {
                              "resource_group": "MyResourceGroup",
                              "tag_key": "MyTagKey",
                              "tag_value": "MyTagValue"
                            }
                          ],
                          "scan_all": false
                        },
                        "network_uuid": "00000000-0000-0000-0000-000000000000"
                      }
                    }
                  },
                  "GCP (Keyed)": {
                    "value": {
                      "connector": {
                        "type": "gcp",
                        "human_type": "GCP",
                        "data_type": "assets",
                        "name": "GCP Connector",
                        "status": "Scheduled",
                        "status_message": "",
                        "schedule": {
                          "units": "minutes",
                          "value": 30,
                          "is_empty": false
                        },
                        "date_created": "2026-08-24T13:20:44.826Z",
                        "id": "1deacf47-eabe-4fec-9fa4-6c13a88203a9",
                        "container_uuid": "4a80392b-646e-4a45-ba07-5670efee1bf9",
                        "expired": false,
                        "incremental_mode": false,
                        "params": {
                          "service": "gcp"
                        },
                        "network_uuid": "00000000-0000-0000-0000-000000000000"
                      }
                    }
                  },
                  "GCP Workload Identity Federation": {
                    "value": {
                      "connector": {
                        "type": "gcp_keyless",
                        "human_type": "GCP",
                        "data_type": "assets",
                        "name": "GCP Workload Identity Federation Connector",
                        "status": "Scheduled",
                        "status_message": "",
                        "schedule": {
                          "units": "days",
                          "value": 1,
                          "is_empty": false
                        },
                        "date_created": "2026-01-13T17:44:05.752Z",
                        "id": "fdb15b71-231d-4b5d-a50f-460321659854",
                        "container_uuid": "a236c1a2-4aa2-46ca-9435-289a19e6df2d",
                        "expired": false,
                        "incremental_mode": false,
                        "params": {
                          "service": "gcp_keyless"
                        },
                        "network_uuid": "00000000-0000-0000-0000-000000000000"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Returned if your request specified invalid parameters or if your request was improperly formatted."
          },
          "401": {
            "description": "Returned if the API keys specified in your request are invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Cloud_Connectors_ErrorResponse"
                },
                "examples": {
                  "response": {
                    "value": {
                      "statusCode": 401,
                      "error": "Unauthorized",
                      "message": "Invalid credentials."
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Returned if you do not have permission to create a cloud connector."
          },
          "429": {
            "description": "Returned if you attempt to send too many requests in a specific period of time. For more information, see [Rate Limiting](doc:rate-limiting).",
            "content": {
              "text/html": {
                "examples": {
                  "response": {
                    "value": "<html>\n\n<head>\n    <title>429 Too Many Requests</title>\n</head>\n\n<body bgcolor=\"white\">\n    <center>\n        <h1>429 Too Many Requests</h1>\n    </center>\n    <hr>\n    <center>nginx</center>\n</body>\n\n</html>"
                  }
                }
              }
            }
          },
          "500": {
            "description": "Returned if an internal error occurred.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Cloud_Connectors_ErrorResponse"
                },
                "examples": {
                  "response": {
                    "value": {
                      "statusCode": 500,
                      "error": "Internal Server Error",
                      "message": "An internal server error occurred. Please wait a moment and try your request again."
                    }
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "cloud": []
          }
        ]
      }
    }
  },
  "components": {
    "securitySchemes": {
      "cloud": {
        "type": "apiKey",
        "in": "header",
        "name": "X-ApiKeys",
        "description": "Format - accessKey=ACCESS_KEY;secretKey=SECRET_KEY"
      }
    },
    "schemas": {
      "Cloud_Connectors_Request-ConnectorCreate": {
        "oneOf": [
          {
            "title": "Amazon Web Services (Keyed)",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Amazon Web Services (AWS) keyed connector.",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_AWS_Keyed_Connector"
              }
            }
          },
          {
            "title": "Amazon Web Services (Keyless)",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Amazon Web Services (AWS) keyless connector.",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_AWS_Keyless_Connector"
              }
            }
          },
          {
            "title": "Amazon Web Services with Frictionless Assessment",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Amazon Web Services (AWS) with Frictionless Assessment connector.\n\n**Note:** Frictionless Assessment has reached the End-of-Provisioning phase of its product lifecycle. For more information, see [Frictionless Assessment End-of-Provisioning](https://developer.tenable.com/changelog/tenableio-frictionless-assessment-end-of-provisioning).",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_AWS_FA_Connector"
              }
            }
          },
          {
            "title": "Microsoft Azure",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Microsoft Azure connector.",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_Azure_Connector"
              }
            }
          },
          {
            "title": "Microsoft Azure with Frictionless Assessment",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Microsoft Azure with Frictionless Assessment connector.\n\n**Note:** Frictionless Assessment has reached the End-of-Provisioning phase of its product lifecycle. For more information, see [Frictionless Assessment End-of-Provisioning](https://developer.tenable.com/changelog/tenableio-frictionless-assessment-end-of-provisioning).",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_Azure_ConnectorFA"
              }
            }
          },
          {
            "title": "Google Cloud Platform (Keyed)",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Google Cloud Platform (GCP) keyed connector.",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_GCP_Keyed_Connector"
              }
            }
          },
          {
            "title": "Google Cloud Platform Workload Identity Federation",
            "type": "object",
            "description": "There are several types of cloud connectors. Each cloud connector type requires different parameters. This option displays only the parameters for the Google Cloud Platform (GCP) Workload Identity Federation connector.",
            "properties": {
              "connector": {
                "$ref": "#/components/schemas/Cloud_Connectors_Request-Create_GCP_Keyless_Connector"
              }
            }
          }
        ]
      },
      "Cloud_Connectors_Request-Create_AWS_Keyed_Connector": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For AWS keyed connectors, the type is `aws`.",
            "default": "aws",
            "enum": [
              "aws"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestAWSKeyed"
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Request-Create_AWS_Keyless_Connector": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For AWS keyless connectors, the type is `aws_keyless`.",
            "default": "aws_keyless",
            "enum": [
              "aws_keyless"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestAWSKeyless"
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Request-Create_AWS_FA_Connector": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For AWS with Frictionless Assessment connectors, the type is `aws_fa`.",
            "default": "aws_fa",
            "enum": [
              "aws_fa"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestAWS_FA"
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Request-Create_Azure_Connector": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For Azure connectors, the type is `azure`.",
            "default": "azure",
            "enum": [
              "azure"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestAzure"
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Request-Create_Azure_ConnectorFA": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For Azure with Frictionless Assessment connectors, the type is `azure_fa`.",
            "default": "azure_fa",
            "enum": [
              "azure_fa"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestAzureFA"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Request-Create_GCP_Keyed_Connector": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For GCP keyed connectors, the type is `gcp`.",
            "default": "gcp",
            "enum": [
              "gcp"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestGCP"
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Request-Create_GCP_Keyless_Connector": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name can contain only alphanumeric characters, commas, periods, dashes, at signs, and underscores."
          },
          "type": {
            "type": "string",
            "description": "The type of cloud connector. For GCP Workload Identity Federation connectors, the type is `gcp_keyless`.",
            "default": "gcp_keyless",
            "enum": [
              "gcp_keyless"
            ]
          },
          "network_uuid": {
            "type": "string",
            "description": "The UUID of the [network](doc:manage-networks) to associate with the cloud connector. You can find the UUID using the [GET /networks](ref:networks-list) endpoint. If you do not specify a network, Tenable Vulnerability Management automatically associates the connector with the default network (UUID `00000000-0000-0000-0000-000000000000`).\n\nNote: Tenable recommends creating a network for each connector type in use to prevent asset records in different cloud environments from overwriting each other. For more information, see [Managing Networks](doc:manage-networks).",
            "format": "UUID",
            "default": "00000000-0000-0000-0000-000000000000"
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_ParamsRequestGCPKeyless"
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        },
        "required": [
          "name",
          "type",
          "params"
        ]
      },
      "Cloud_Connectors_Response-Connector": {
        "type": "object",
        "properties": {
          "type": {
            "type": "string",
            "description": "The type of cloud connector. Types include `aws`, `aws_keyless`, `aws_fa`, `azure`, `azure_fa`, `gcp`, or `gcp_keyless`."
          },
          "human_type": {
            "type": "string",
            "description": "The human-readable connector type."
          },
          "data_type": {
            "type": "string",
            "description": "The data type imported by the connector. This value is always `assets`."
          },
          "name": {
            "type": "string",
            "description": "The name of the cloud connector. The name must be unique within a Tenable Vulnerability Management instance."
          },
          "status": {
            "type": "string",
            "description": "The import status of the connector. Status values can include:\n - Completed—Tenable Vulnerability Management successfully used the connector to import assets (no imports scheduled)\n - Scheduled—Imports using the connector are scheduled for future dates\n - Saved—Tenable Vulnerability Management saved the connector configuration, but did not import assets at this time (no imports scheduled)\n - Error—Tenable Vulnerability Management failed to import assets using the connector"
          },
          "is_fa": {
            "type": "boolean",
            "description": "For AWS keyless connectors, indicates whether Frictionless Assessment is enabled or not."
          },
          "status_message": {
            "type": "string",
            "description": "Extended description of the connector status. If Frictionless Assessment is enabled, this property is set to `FA Enabled`. For information about connector error codes, see [Connectors](doc:connectors)."
          },
          "schedule": {
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          },
          "date_created": {
            "type": "string",
            "description": "An ISO timestamp indicating the date and time on which the connector was created, for example, `2025-12-31T13:51:17.243Z`."
          },
          "date_modified": {
            "type": "string",
            "description": "An ISO timestamp indicating the date and time on which the connector was last modified or new records were imported, for example, `2025-12-31T13:51:17.243Z`."
          },
          "id": {
            "type": "string",
            "description": "The UUID of the connector."
          },
          "container_uuid": {
            "type": "string",
            "description": "The UUID of the Tenable Vulnerability Management instance."
          },
          "expired": {
            "type": "boolean",
            "description": "Indicates whether the Vulnerability Management license for the Tenable Vulnerability Management instance associated with the connector is expired."
          },
          "incremental_mode": {
            "type": "boolean",
            "description": "Indicates whether a connector has completed the initial full import successfully. If the value is `true`, then the connector is in incremental mode where it imports assets based on on the service provider event stream instead of enumerating all assets in the account every single time."
          },
          "params": {
            "$ref": "#/components/schemas/Cloud_Connectors_response_params"
          },
          "last_sync_time": {
            "type": "string",
            "description": "An ISO timestamp indicating the date and time of the last successful import, for example, `2025-12-31T13:51:17.243Z`."
          },
          "network_uuid": {
            "type": "string",
            "format": "UUID",
            "description": "The UUID of the [network](doc:manage-networks) associated with the connector."
          },
          "enabled": {
            "type": "boolean",
            "description": "Indicates whether the connector is enabled."
          },
          "expired_on": {
            "type": "string",
            "format": "date-time",
            "description": "The date and time when the connector's credentials expired."
          },
          "last_run": {
            "type": "string",
            "format": "date-time",
            "description": "The date and time when the connector last ran."
          },
          "last_seen_updated": {
            "type": "string",
            "format": "date-time",
            "description": "The date and time when the connector last updated the last-seen data for its assets."
          },
          "schedule_full": {
            "description": "The schedule for full (non-incremental) data imports.",
            "$ref": "#/components/schemas/Cloud_Connectors_schedule"
          }
        }
      },
      "Cloud_Connectors_schedule": {
        "type": "object",
        "description": "The data import schedule.",
        "properties": {
          "units": {
            "type": "string",
            "description": "The units of time for the import interval. Units can include `days`, `hours`, `minutes`."
          },
          "value": {
            "type": "integer",
            "description": "The number of units between import intervals."
          },
          "is_empty": {
            "type": "boolean",
            "description": "Indicates whether the schedule is unset."
          }
        }
      },
      "Cloud_Connectors_response_params": {
        "type": "object",
        "description": "The connector parameters. Note that only the `params` object for AWS keyed connectors is shown below. The `param` object for other connector types is not used in the example.",
        "properties": {
          "access_key": {
            "description": "For AWS connectors, the AWS access key.\n\n<b>Note: </b>The `access_key` is not included in the keyless AWS connector parameters.",
            "type": "string"
          },
          "sub_accounts": {
            "description": "For AWS connectors, a list of AWS accounts associated with the connector.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_aws_sub_account"
            }
          },
          "status": {
            "description": "For Azure connectors, a list of import status records.",
            "type": "object",
            "additionalProperties": {
              "$ref": "#/components/schemas/Cloud_Connectors_azure_status"
            }
          },
          "targets": {
            "description": "For Azure Frictionless Assessment connectors, the resource group and tag information.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_TargetsAzureFA"
            }
          },
          "application_id": {
            "description": "For Azure connectors, the Azure application ID.",
            "type": "string"
          },
          "tenant_id": {
            "type": "string",
            "description": "For Azure connectors, the Azure tenant ID (directory ID)."
          },
          "subscription_id": {
            "type": "string",
            "description": "For Azure connectors, the Azure subscription ID. If you do not provide subscription IDs, Tenable Vulnerability Management automatically discovers them."
          },
          "auto_discovery": {
            "description": "Specifies whether Auto Discovery is enabled or not for AWS keyless connectors. If Auto Discovery is enabled, the connector will automatically discover linked accounts and CloudTrails.",
            "type": "boolean"
          },
          "service": {
            "description": "The service targeted by the connector. Values include `aws`, `aws_keyless`, `aws_fa`, `azure`, `azure_fa`, and `gcp`.",
            "type": "string"
          },
          "account": {
            "type": "object",
            "description": "For AWS connectors, the account the connector imports data from.",
            "properties": {
              "account_id": {
                "type": "string",
                "description": "The AWS account ID."
              },
              "role_arn": {
                "type": "string",
                "description": "The Amazon Resource Name (ARN) of the role the connector assumes."
              }
            }
          },
          "import_config": {
            "type": "boolean",
            "description": "Indicates whether the connector imports configuration data in addition to asset data."
          },
          "scan_all": {
            "type": "boolean",
            "description": "Indicates whether the connector imports all discovered assets rather than only those matching its tag filters."
          },
          "tag": {
            "description": "For connectors filtered by a single tag, the tag to match.",
            "type": "object",
            "properties": {
              "key": {
                "type": "string",
                "description": "The tag key."
              },
              "value": {
                "type": "string",
                "description": "The tag value."
              }
            }
          },
          "tags": {
            "type": "array",
            "description": "For connectors filtered by tags, the tags to match.",
            "items": {
              "type": "object",
              "properties": {
                "key": {
                  "type": "string",
                  "description": "The tag key."
                },
                "value": {
                  "type": "string",
                  "description": "The tag value."
                }
              }
            }
          },
          "trails": {
            "type": "array",
            "description": "For AWS connectors, the cloudtrails the connector reads from.",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_trail"
            }
          }
        }
      },
      "Cloud_Connectors_ParamsRequestAWSKeyed": {
        "type": "object",
        "properties": {
          "access_key": {
            "description": "The AWS access key.",
            "type": "string"
          },
          "secret_key": {
            "description": "The AWS secret key.",
            "type": "string"
          },
          "trails": {
            "description": "A list of AWS cloudtrails associated with the connector. The trails must be available to be used by the connector. Use the [POST /settings/connectors/aws/cloudtrails](ref:io-connectors-get-aws-cloudtrails) endpoint to check the `availability` property of cloudtrail objects.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_trail"
            }
          }
        },
        "required": [
          "access_key",
          "secret_key"
        ]
      },
      "Cloud_Connectors_ParamsRequestAWSKeyless": {
        "required": [
          "sub_accounts"
        ],
        "type": "object",
        "properties": {
          "tags": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_tags"
            }
          },
          "auto_discovery": {
            "description": "Specifies whether Auto Discovery is enabled or not. If Auto Discovery is enabled, the connector will automatically discover linked accounts and CloudTrails.",
            "type": "boolean"
          },
          "sub_accounts": {
            "description": "A list of AWS accounts associated with the connector.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_aws_sub_account"
            }
          },
          "trails": {
            "description": "A list of AWS cloudtrails associated with the connector. The trails must be available to be used by the connector. Use the [POST /settings/connectors/aws/cloudtrails](ref:io-connectors-get-aws-cloudtrails) endpoint to check the `availability` property of cloudtrail objects.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_trail"
            }
          }
        }
      },
      "Cloud_Connectors_ParamsRequestAWS_FA": {
        "type": "object",
        "properties": {
          "tag": {
            "$ref": "#/components/schemas/Cloud_Connectors_tags"
          },
          "account": {
            "description": "The AWS account associated with the connector.",
            "type": "object",
            "properties": {
              "account_id": {
                "type": "string",
                "description": "The AWS account ID."
              }
            }
          }
        }
      },
      "Cloud_Connectors_ParamsRequestAzure": {
        "type": "object",
        "properties": {
          "application_id": {
            "description": "The Microsoft Azure application ID.",
            "type": "string"
          },
          "tenant_id": {
            "type": "string",
            "description": "The Microsoft Azure tenant ID (directory ID)."
          },
          "client_secret": {
            "type": "string",
            "description": "The Microsoft Azure client secret value."
          },
          "subscription_id": {
            "type": "string",
            "description": "The Microsoft Azure subscription ID. If you do not provide subscription IDs, Tenable Vulnerability Management automatically discovers them."
          }
        },
        "required": [
          "application_id",
          "tenant_id",
          "client_secret"
        ]
      },
      "Cloud_Connectors_ParamsRequestAzureFA": {
        "type": "object",
        "properties": {
          "targets": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_TargetsAzureFA"
            }
          },
          "scan_all": {
            "type": "boolean",
            "description": "Indicates whether or not to override the `resource_group`, `tag_key`, and `tag_value` properties and scan all VMs in the current subscription. Setting `scan_all` to `true` is equivalent to using `*` for `resource_group`, `tag_key`, and `tag_value`.",
            "example": false
          },
          "application_id": {
            "description": "The Microsoft Azure application ID.",
            "type": "string"
          },
          "tenant_id": {
            "type": "string",
            "description": "The Microsoft Azure tenant ID (directory ID)."
          },
          "client_secret": {
            "type": "string",
            "description": "The Microsoft Azure client secret value."
          }
        },
        "required": [
          "application_id",
          "tenant_id",
          "client_secret"
        ]
      },
      "Cloud_Connectors_TargetsAzureFA": {
        "type": "object",
        "properties": {
          "resource_group": {
            "description": "The name of the resource group that Azure Frictionless Assessment scans VMs in. \n\n**Note:** You can use the wildcard `*` to select all resource groups in the Azure subscription.",
            "type": "string"
          },
          "tag_key": {
            "type": "string",
            "description": "The tag name in Microsoft Azure. \n\n**Note:** You can use the wildcard `*` to select all tag names in Azure for Frictionless Assessment."
          },
          "tag_value": {
            "type": "string",
            "description": "The tag value in Microsoft Azure. \n\n**Note:** You can use the wildcard `*` to select all tag values in Azure for Frictionless Assessment."
          }
        }
      },
      "Cloud_Connectors_ParamsRequestGCP": {
        "type": "object",
        "properties": {
          "service_account_key": {
            "type": "string",
            "description": "A Base64-encoded string value of the service account key JSON file. For more information, see <a href=\"https://cloud.google.com/iam/docs/creating-managing-service-account-keys\" target=\"_blank\">Create and delete service account keys</a> in the GCP documentation.\n\nNote: The `service_account_key` value must include only the literal encoded string. Do not include the `data:application/json;base64` prefix."
          }
        },
        "required": [
          "service_account_key"
        ]
      },
      "Cloud_Connectors_ParamsRequestGCPKeyless": {
        "type": "object",
        "properties": {
          "credentials_config": {
            "type": "string",
            "description": "A Base64-encoded string value of the credential configuration. \n\nFor more information, see <a href=\"https://docs.tenable.com/vulnerability-management/Content/Settings/cloud-connectors/GCP/CreateWorkloadIdentityPool.htm\" target=\"_blank\">Create a GCP Workload Identity Pool and Download the Configuration File</a> in the _Tenable Vulnerability Management User Guide_ or <a href=\"https://cloud.google.com/iam/docs/workload-identity-federation-with-other-providers#download-cred-config\" target=\"_blank\">Download a credential configuration</a> in the GCP documentation.\n\nNote: The `credentials_config` value must include only the literal encoded string. Do not include the `data:application/json;base64` prefix."
          }
        },
        "required": [
          "credentials_config"
        ]
      },
      "Cloud_Connectors_tags": {
        "description": "The AWS tag associated with the hosts you want to assess. \n\n**Note:** You can no longer use Frictionless Assessment tags to create an AWS keyless (`aws_keyless`) connector with Frictionless Assessment. To create an AWS with Frictionless Assessment connector, use the `aws_fa` connector type when creating the connector.",
        "type": "object",
        "properties": {
          "key": {
            "description": "The AWS tag associated with the hosts you want to assess.",
            "type": "string"
          },
          "value": {
            "description": "The value of the AWS tag associated with the hosts you want to assess.",
            "type": "string"
          }
        }
      },
      "Cloud_Connectors_trail": {
        "required": [
          "arn"
        ],
        "type": "object",
        "properties": {
          "arn": {
            "type": "string",
            "description": "The Amazon Resource Name (ARN) of the cloudtrail."
          },
          "name": {
            "type": "string",
            "description": "The name of the cloudtrail."
          },
          "region": {
            "$ref": "#/components/schemas/Cloud_Connectors_region"
          },
          "availability": {
            "description": "Indicates whether a cloudtrail is available to be used by a connector (logging is turned on in AWS, or it has at least one EventSelector with IncludeManagementEvents). Values include:\n - `success`—The cloudtrail is available.\n - `error`—The cloudtrail is not available.",
            "type": "string",
            "enum": [
              "success",
              "error"
            ]
          }
        }
      },
      "Cloud_Connectors_region": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The AWS region code, for example, `us-east-1`. The value of `All` indicates that the cloudtrail is associated with all AWS available regions."
          },
          "friendly_name": {
            "description": "The AWS region name, for example, `US East (N. Virginia)`. The value of `All` indicates that the cloudtrail is associated with all AWS available regions.",
            "type": "string"
          }
        }
      },
      "Cloud_Connectors_aws_sub_account": {
        "required": [
          "account_id",
          "role_arn",
          "external_id",
          "trails"
        ],
        "type": "object",
        "properties": {
          "account_id": {
            "type": "string",
            "description": "The AWS account ID."
          },
          "role_arn": {
            "type": "string",
            "description": "The Amazon Resource Name (ARN) of the role generated based on the associated account ID."
          },
          "external_id": {
            "description": "The UUID of your Tenable Vulnerability Management instance used by AWS to identify it as a client application. You can obtain the UUID of your Tenable Vulnerability Management account using the [GET /users/{user_id}](ref:users-details) endpoint. The UUID corresponds to the `container_uuid` attribute of the response message for that endpoint.",
            "type": "string"
          },
          "trails": {
            "description": "A list of AWS cloudtrails associated with the account.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cloud_Connectors_trail"
            }
          },
          "incremental_mode": {
            "type": "boolean",
            "description": "Indicates whether a connector has completed the initial full import successfully. If the value is `true`, then the connector is in incremental mode where it imports assets based on events instead of enumerating all assets in the account every single time."
          }
        }
      },
      "Cloud_Connectors_azure_status": {
        "type": "object",
        "properties": {
          "last_event_seen": {
            "type": "string",
            "description": "An ISO timestamp indicating the last time the connector found new or changed records and successfully imported them."
          },
          "release_timestamp": {
            "description": "An ISO timestamp indicating the last time the connector successfully completed an import (regardless of whether it found any changes).",
            "type": "string"
          },
          "message": {
            "type": "string",
            "description": "The extended import status message."
          },
          "state": {
            "type": "string",
            "description": "The outcome of the connector's last import for this target, for example `SUCCESS` or `ERROR`."
          }
        }
      },
      "Cloud_Connectors_ErrorResponse": {
        "type": "object",
        "properties": {
          "statusCode": {
            "type": "integer",
            "description": "The HTTP status code of the error."
          },
          "error": {
            "type": "string",
            "description": "The standard HTTP error name."
          },
          "message": {
            "type": "string",
            "description": "A brief message about the cause of the error."
          }
        }
      }
    }
  },
  "x-readme": {
    "proxy-enabled": false,
    "samples-languages": [
      "python",
      "curl",
      "node",
      "powershell",
      "ruby",
      "javascript",
      "objectivec",
      "java",
      "php",
      "csharp",
      "go",
      "swift",
      "kotlin"
    ]
  }
}
```